function Create(self)
self.PI = 3.14159265358;
self.LBoost = CreateAEmitter("Nil Engine","SWAT Kats.rte");
self.RBoost = CreateAEmitter("Nil Engine","SWAT Kats.rte");
self.CBoost = CreateAEmitter("Nil Engine","SWAT Kats.rte");
MovableMan:AddParticle(self.LBoost);
MovableMan:AddParticle(self.RBoost);
MovableMan:AddParticle(self.CBoost);
self.LBID = self.LBoost.ID;
self.RBID = self.RBoost.ID;
self.CBID = self.CBoost.ID;
self.LBPos = Vector(-37,12);
self.RBPos = Vector(37,12);
self.CBPos = Vector(0,30);
self.LPush = 5000;
self.RPush = 5000;
self.CPush = 10000;
self.LOPush = 5000;
self.ROPush = 5000;
self.COPush = 10000;
self.LTPush = self.LOPush;
self.RTPush = self.ROPush;
self.CTPush = self.COPush;

self.Facing = 0;

self.Autopilot = true;
self.TargetRoll = 0;
self.TargetClimbRate = 0;
self.TargetVelocity = 0;
self.TargetRollRate = 0;
self.MaintainAltitude = true;
self.TargetAltitude = self.Pos.Y;
end

function Destroy(self)

end

function Update(self)
	--Update boosters
	self.LTPush = self.LOPush;
	self.RTPush = self.ROPush;
	self.CTPush = self.COPush;
	self.TargetRoll = 0;
	self.TargetClimbRate = 0;
	self.TargetVelocity = 0;
	self.TargetRollRate = 0;
	self.MaintainAltitude = true;

	--start control
	--toggle autopilot
	if self:GetController():IsPlayerControlled(1) and UInputMan:KeyPressed(26) then
		if self.Autopilot then
			self.Autopilot = false;
		else
			self.Autopilot = true;
		end
	end
	--check rotation
	if self:GetController():IsPlayerControlled(1) and UInputMan:KeyPressed(18) then
		self.Facing = self.Facing +1;
		if self.Facing > 1 then
			self.Facing = -1;
		end
	end
	if self:GetController():IsPlayerControlled(1) and UInputMan:KeyPressed(20) then
		self.Facing = self.Facing -1;
		if self.Facing < -1 then
			self.Facing = 1;
		end
	end
	--update facing and vars
	if self.Facing == 0 then
		self.Frame = 0;
		self.LBPos = Vector(-37,12);
		self.RBPos = Vector(37,12);
		self.CBPos = Vector(0,30);
		self.LOPush = 5000;
		self.ROPush = 5000;
		self.COPush = 10000;
	end
	if self.Facing == 1 then
		self.Frame = 1;
		self.LBPos = Vector(-57,12);
		self.RBPos = Vector(-57,12);
		self.CBPos = Vector(150,30);
		self.LOPush = 7000;
		self.ROPush = 7000;
		self.COPush = 6000;
	end
	if self.Facing == -1 then
		self.Frame = 2;
		self.LBPos = Vector(57,12);
		self.RBPos = Vector(57,12);
		self.CBPos = Vector(-150,30);
		self.LOPush = 7000;
		self.ROPush = 7000;
		self.COPush = 6000;
	end

	--check autopilot
	if self.Autopilot then
		if self:GetController():IsState(Controller.HOLD_LEFT) then
			self.TargetVelocity = self.TargetVelocity - 10;
			--ConsoleMan:PrintString("Control Input MOVE LEFT; setting Target Velocity LOW");
		end
		if self:GetController():IsState(Controller.HOLD_RIGHT) then
			self.TargetVelocity = self.TargetVelocity + 10;
			--ConsoleMan:PrintString("Control Input MOVE RIGHT; setting Target Velocity HIGH");
		end
		if self:GetController():IsState(Controller.HOLD_DOWN) then
			self.TargetClimbRate = self.TargetClimbRate + 4;
			self.MaintainAltitude = false;
			self.TargetAltitude = self.Pos.Y;
			--ConsoleMan:PrintString("Control Input MOVE DOWN; setting Climbrate HIGH (Y reverse)");
		end
		if self:GetController():IsState(Controller.HOLD_UP) then
			self.TargetClimbRate = self.TargetClimbRate - 4;
			self.MaintainAltitude = false;
			self.TargetAltitude = self.Pos.Y;
			--ConsoleMan:PrintString("Control Input MOVE UP; setting Target Velocity LOW (Y reverse)");
		end

	--apply autopilot
	--if velocity far less than target, adjust target roll
	if math.abs(self.Vel.X - self.TargetVelocity)>1 then --and math.abs(self.RotAngle-self.TargetRoll)>self.PI/60 then
		if self.Vel.X < self.TargetVelocity then
			self.TargetRoll = -1*self.PI/6;
			--ConsoleMan:PrintString("Velocity too low; Adjusting target roll to RIGHT");
		end
		if self.Vel.X > self.TargetVelocity then
			self.TargetRoll = self.PI/6;
			--ConsoleMan:PrintString("Velocity too high; Adjusting target roll to LEFT");
		end
	end
	--if velocity far less than target and rotation sufficient, apply thrust to stop rotation
	if math.abs(self.Vel.X - self.TargetVelocity)>5 and math.abs(self.RotAngle-self.TargetRoll)<self.PI/60 then
		self.TargetRoll = self.RotAngle;
		--self.CTPush = self.CTPush*5;
		--ConsoleMan:PrintString("Velocity too low; Roll sufficient; Fixing ROLL");
	end
	--if velocity near target and rotation sufficient, adjust target roll and decelerate
	if math.abs(self.Vel.X - self.TargetVelocity)<1 and math.abs(self.RotAngle-self.TargetRoll)<=self.PI/60 and math.abs(self.TargetVelocity)>0 then
		if self.Vel.X > self.TargetVelocity then
			self.TargetRoll = self.PI/90;
			--ConsoleMan:PrintString("Velocity sufficient; Adjusting roll to LEVEL");
		end
		if self.Vel.X < self.TargetVelocity then
			self.TargetRoll = -1*self.PI/90;
			--ConsoleMan:PrintString("Velocity sufficient; Adjusting roll to LEVEL");
		end
	end
	--if altitude low, adjust climb rate
	if self.MaintainAltitude then
	if math.abs(self.Pos.Y - self.TargetAltitude)>5 then
		if self.TargetAltitude < self.Pos.Y then
			self.TargetClimbRate = (self.TargetAltitude-self.Pos.Y)/10;
			--ConsoleMan:PrintString("Altitude too low; setting Climbrate HIGH (Y reverse)");
		end
		if self.TargetClimbRate > self.Pos.Y then
			self.TargetClimbRate = (self.Pos.Y-self.TargetAltitude)/10;
			--ConsoleMan:PrintString("Altitude too high; setting Climbrate LOW (Y reverse)");
		end
	end
	end
	
	--if climb rate different, adjust thrust
	if math.abs(self.Vel.Y - self.TargetClimbRate)>0.5 then
		if self.TargetClimbRate < self.Vel.Y then
			if self.Facing == 0 then
			self.CTPush = self.CTPush * 5;
			self.LTPush = self.LTPush * 1.2;
			self.RTPush = self.RTPush * 1.2;
			end
			if self.Facing == 1 or self.Facing == -1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 3;
			end
			--ConsoleMan:PrintString("Climbrate insufficient; setting Thrust to HIGH");
		end
		if self.TargetClimbRate > self.Vel.Y then
			if self.Facing == 0 then
			self.CTPush = self.CTPush * 0.1;
			self.LTPush = self.LTPush * 0.3;
			self.RTPush = self.RTPush * 0.3;
			end
			if self.Facing == 1 or self.Facing == -1 then
			self.CTPush = self.CTPush * 0.3;
			self.LTPush = self.LTPush * 0.2;
			self.RTPush = self.RTPush * 0.2;
			end
			--ConsoleMan:PrintString("Climbrate excessive; setting Thrust to LOW");
		end
	end

	--if rotation too great, adjust desired rotation speed
	if math.abs(self.RotAngle - self.TargetRoll)>self.PI/180 then
		if self.TargetRoll < self.RotAngle then
			self.TargetRollRate = -1*self.PI/18;
			--ConsoleMan:PrintString("Roll target different; rotating RIGHT");
		end
		if self.TargetRoll > self.RotAngle then
			self.TargetRollRate = self.PI/18;
			--ConsoleMan:PrintString("Roll target different; rotating LEFT");
		end
	end
	--if rotation speed different, adjust thrust
	if math.abs(self.AngularVel - self.TargetRollRate)>self.PI/1800 then
		if self.TargetRollRate < self.AngularVel then
			if self.Facing == 0 then
			self.LTPush = self.LTPush * -0.5;
			self.RTPush = self.RTPush * 4;
			end
			if self.Facing == 1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 1.1;
			self.RTPush = self.RTPush * 1.1;
			end
			if self.Facing == -1 then
			self.CTPush = self.CTPush * 0.5;
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 3;
			end
			--ConsoleMan:PrintString("Rolling clockwise too fast; Adjusting thrust bias to RIGHT");
		end
		if self.TargetRollRate > self.AngularVel then
			if self.Facing == 0 then
			self.LTPush = self.LTPush * 4;
			self.RTPush = self.RTPush * -0.5;
			end
			if self.Facing == -1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 1.1;
			self.RTPush = self.RTPush * 1.1;
			end
			if self.Facing == 1 then
			self.CTPush = self.CTPush * 0.5;
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 3;
			end
			--ConsoleMan:PrintString("Rolling counterclockwise too fast; Adjusting thrust bias to LEFT");
		end
	end


	else --manual (not recommended)
	--Alter thrust
		if self:GetController():IsState(Controller.HOLD_LEFT) then
			self.TargetRoll = self.PI;
		end
		if self:GetController():IsState(Controller.HOLD_RIGHT) then
			self.TargetRoll = -1*self.PI;
		end
		if self:GetController():IsState(Controller.HOLD_DOWN) then
			if self.Facing == 0 then
			self.CTPush = self.CTPush * 0.1;
			self.LTPush = self.LTPush * 0.3;
			self.RTPush = self.RTPush * 0.3;
			end
			if self.Facing == 1 or self.Facing == -1 then
			self.CTPush = self.CTPush * 0.3;
			self.LTPush = self.LTPush * 0.2;
			self.RTPush = self.RTPush * 0.2;
			end
		end
		if self:GetController():IsState(Controller.HOLD_UP) then
			if self.Facing == 0 then
			self.CTPush = self.CTPush * 5;
			self.LTPush = self.LTPush * 1.2;
			self.RTPush = self.RTPush * 1.2;
			end
			if self.Facing == 1 or self.Facing == -1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 3;
			end
		end

	--if rotation too great, adjust desired rotation speed
	if math.abs(self.RotAngle - self.TargetRoll)>self.PI/180 then
		if self.TargetRoll < self.RotAngle then
			self.TargetRollRate = -1*self.PI/18;
			--ConsoleMan:PrintString("Roll target different; rotating RIGHT");
		end
		if self.TargetRoll > self.RotAngle then
			self.TargetRollRate = self.PI/18;
			--ConsoleMan:PrintString("Roll target different; rotating LEFT");
		end
	end
	--if rotation speed different, adjust thrust
	if math.abs(self.AngularVel - self.TargetRollRate)>self.PI/1800 then
		if self.TargetRollRate < self.AngularVel then
			if self.Facing == 0 then
			self.LTPush = self.LTPush * -0.5;
			self.RTPush = self.RTPush * 4;
			end
			if self.Facing == 1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 1.1;
			self.RTPush = self.RTPush * 1.1;
			end
			if self.Facing == -1 then
			self.CTPush = self.CTPush * 0.5;
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 3;
			end
			--ConsoleMan:PrintString("Rolling clockwise too fast; Adjusting thrust bias to RIGHT");
		end
		if self.TargetRollRate > self.AngularVel then
			if self.Facing == 0 then
			self.LTPush = self.LTPush * 4;
			self.RTPush = self.RTPush * -0.5;
			end
			if self.Facing == -1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 1.1;
			self.RTPush = self.RTPush * 1.1;
			end
			if self.Facing == 1 then
			self.CTPush = self.CTPush * 0.5;
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 3;
			end
			--ConsoleMan:PrintString("Rolling counterclockwise too fast; Adjusting thrust bias to LEFT");
		end
	end
	end --end control

	--Tween push
	-- self.CPush = self.CPush + ((self.CTPush - self.CPush)/10)
	if self.CTPush > self.CPush then
		self.CPush = self.CPush + ((self.CTPush - self.CPush)/10);
	end
	if self.LTPush > self.LPush then
		self.LPush = self.LPush + ((self.LTPush - self.LPush)/10);
	end
	if self.RTPush > self.RPush then
		self.RPush = self.RPush + ((self.RTPush - self.RPush)/10);
	end
	if self.CTPush < self.CPush then
		self.CPush = self.CPush - ((self.CPush - self.CTPush)/10);
	end
	if self.LTPush < self.LPush then
		self.LPush = self.LPush - ((self.LPush - self.LTPush)/10);
	end
	if self.RTPush < self.RPush then
		self.RPush = self.RPush - ((self.RPush - self.RTPush)/10);
	end

	--ConsoleMan:PrintString(tostring(self.LBID));
	--ConsoleMan:PrintString(tostring(MovableMan:GetMOFromID(self.LBID)));	

	--Apply proper angle (facing down) and shift position, then add thrust
	if not (MovableMan:GetMOFromID(self.LBID) == "nil") then
	self.LBoost.RotAngle = self.RotAngle+(self.PI/2)+0.3;
	self.LBoost.Pos.X = self.Pos.X + math.cos(self.LBPos.AbsRadAngle - self.RotAngle)*-1*self.LBPos.Magnitude;
	self.LBoost.Pos.Y = self.Pos.Y + math.sin(self.LBPos.AbsRadAngle - self.RotAngle)*1*self.LBPos.Magnitude;
	self:AddAbsForce(Vector(math.cos(self.LBoost.RotAngle)*self.LPush,math.sin(self.LBoost.RotAngle)*-1*self.LPush), self.LBoost.Pos);
	end
	if not (MovableMan:GetMOFromID(self.RBID) == "nil") then
	self.RBoost.RotAngle = self.RotAngle+(self.PI/2)-0.3;
	self.RBoost.Pos.X = self.Pos.X + math.cos(self.RBPos.AbsRadAngle - self.RotAngle)*-1*self.RBPos.Magnitude;
	self.RBoost.Pos.Y = self.Pos.Y + math.sin(self.RBPos.AbsRadAngle - self.RotAngle)*1*self.RBPos.Magnitude;
	self:AddAbsForce(Vector(math.cos(self.RBoost.RotAngle)*self.RPush,math.sin(self.RBoost.RotAngle)*-1*self.RPush), self.RBoost.Pos);
	end
	if not (MovableMan:GetMOFromID(self.CBID) == "nil") then
	self.CBoost.RotAngle = self.RotAngle+(self.PI/2);
	self.CBoost.Pos.X = self.Pos.X + math.cos(self.CBPos.AbsRadAngle - self.RotAngle)*-1*self.CBPos.Magnitude;
	self.CBoost.Pos.Y = self.Pos.Y + math.sin(self.CBPos.AbsRadAngle - self.RotAngle)*1*self.CBPos.Magnitude;	
	self:AddAbsForce(Vector(math.cos(self.CBoost.RotAngle)*self.CPush,math.sin(self.CBoost.RotAngle)*-1*self.CPush), self.CBoost.Pos);
	end

	--[[ConsoleMan:PrintString("Target Altitude");
	ConsoleMan:PrintString(tostring(self.TargetAltitude));
	ConsoleMan:PrintString("Actual Altitude");
	ConsoleMan:PrintString(tostring(self.Pos.Y));
	ConsoleMan:PrintString("Target Velocity");
	ConsoleMan:PrintString(tostring(self.TargetVelocity));
	ConsoleMan:PrintString("Actual Velocity");
	ConsoleMan:PrintString(tostring(self.Vel.X));
	ConsoleMan:PrintString("Target Climbrate");
	ConsoleMan:PrintString(tostring(self.TargetClimbRate));
	ConsoleMan:PrintString("Actual Climbrate");
	ConsoleMan:PrintString(tostring(self.Vel.Y));
	ConsoleMan:PrintString("Target Roll");
	ConsoleMan:PrintString(tostring(self.TargetRoll));
	ConsoleMan:PrintString("Actual Roll");
	ConsoleMan:PrintString(tostring(self.RotAngle));
	ConsoleMan:PrintString("Target Rollrate");
	ConsoleMan:PrintString(tostring(self.TargetRollRate));
	ConsoleMan:PrintString("Actual Rollrate");
	ConsoleMan:PrintString(tostring(self.AngularVel));
	ConsoleMan:PrintString("Left Thruster (target/actual)");
	ConsoleMan:PrintString(tostring(self.LTPush));
	ConsoleMan:PrintString(tostring(self.LPush));
	ConsoleMan:PrintString("Center Thruster (target/actual)");
	ConsoleMan:PrintString(tostring(self.CTPush));
	ConsoleMan:PrintString(tostring(self.CPush));
	ConsoleMan:PrintString("Right Thruster (target/actual)");
	ConsoleMan:PrintString(tostring(self.RTPush));
	ConsoleMan:PrintString(tostring(self.RPush));
	ConsoleMan:PrintString("");
	]]--

end